@echo off
::This script loads iw-instrumentation agent onto a running
::JVM instance, identified by its processId (PID).

@echo off
::This script loads iw-instrumentation agent onto a running
::JVM instance, identified by its processId (PID).

::Usage: attach-agent.sh JAVA_HOME PID ADD_TOOLS_LIB 

::JAVA_HOME: used to locate the 'java' program in JAVA_HOME/bin
set JAVA_HOME=%1

::The process Id of the JVM
set PID=%2

::Whether to add 'tools.jar' to the classpath. This is necessary
::for java 1.8 or lower. valid values: 'true' or 'false'
set ADD_TOOLS_LIB=%3

::Optionally provide the location of the tools.jar library. Only for Java 8 or lower
::if tools.jar is not located in the usual location: $JAVA_HOME/lib/tools.jar or $JAVA_HOME/jre/lib/tools.jar
::set JDK_TOOLS_LIB=%SAG_HOME%\jvm\jvm\lib\tools.jar

echo %date% %time% JAVA_HOME: %JAVA_HOME%; PID: %PID%; add tools: %ADD_TOOLS_LIB%

set IWTESTAGENT_JAR=%~dp0..\code\jars\iwtestagent.jar
set IWTESTAGENT_CLASSES=%~dp0..\code\classes
set INSTRUMENTATION_JAR=%~dp0..\resources\lib\iw-instrumentation.jar
if not DEFINED JDK_TOOLS_LIB (set JDK_TOOLS_LIB="")

if exist %IWTESTAGENT_JAR% (
  set CP=%IWTESTAGENT_JAR%
) else (
  set CP=%IWTESTAGENT_CLASSES%
)

if "true" == "%ADD_TOOLS_LIB%" (
  GOTO addtools
) else (
  GOTO execute
) 

:addtools
echo "Adding tools"
if exist %JAVA_HOME%\lib\tools.jar (
  set CP=%CP%;%JAVA_HOME%\lib\tools.jar  
  GOTO execute
) 

echo %JAVA_HOME%\lib\tools.jar does not exist

if exist %JAVA_HOME%\jre\lib\tools.jar (
  set CP=%CP%;%JAVA_HOME%\jre\lib\tools.jar
  GOTO execute
)

echo %JAVA_HOME%\jre\lib\tools.jar does not exist

if "" == "%JDK_TOOLS_LIB% (
  echo tools.jar not found. Cannot attach code coverage agent. To correct, set the environment variable 'JDK_TOOLS_LIB'
  exit /B 3
)

if exist %JDK_TOOLS_LIB% (
  set CP=%CP%;%JDK_TOOLS_LIB%
) else (
  echo JDK_TOOLS_LIB does not point to tools.jar. Please make sure it does.
  exit /B 4
)

:execute

%JAVA_HOME%\bin\java -classpath %CP% iw.test.agent.cv.MyAttacher %PID% %INSTRUMENTATION_JAR%



