(function(window, undefined) {
  window.iw = {

    logleveltable : ["error", "warn", "info", "debug", "trace"],
    
    logginglevel  : 1, 

    logging       : true,
    
    log: function(message, level) {        
      if(iw.logging && window.console) {  //only if if console is defined
        if(level === undefined) level = 2 //info
        if(level <= iw.logginglevel) {
          //console.log("["+iw.logleveltable[level]+"] " + message);
          if(level == 0) console.error(message);
          if(level == 1) console.warn(message);
          if(level == 2) console.info(message);
          if(level == 3) console.debug(message);
          if(level == 4) console.debug(message);
        }
        
      }
    },
    uuidv4 : function() {      
      return ([1e7]+1e3+4e3+8e3+1e11).replace(/[018]/g, c =>
        (c ^ crypto.getRandomValues(new Uint8Array(1))[0] & 15 >> c / 4).toString(16)
      )
    },
    
    /**
		* @input s:  string
		* @input a:  string array
		* @returns : longest common string
		*/
		findLongestCommonString : function (s, a) {
		   iw.log("[find LCS]: start", 3);
		   
         //only evaluate if both s and a are defined and a has at least one element
		   if(!s ||!a || a.length === 0 ) {
		      iw.log("[find LCS]: returning, input doesn't qualify", 4);
		      return s;
		   } 
		   
		   //only evaluate if s is a substring of the first element of a		   
		   if(a[0].indexOf(s) < 0) {
		      iw.log("string is not a substring of " + a[0], 4);
		      return s;
		   }
		   
		   var start = a[0].toLowerCase().indexOf(s.toLowerCase());
		   var sl    = s.length;
		   var ts    = s;

		   iw.log("start: "+start+" ts: " + ts + "; sl: " + sl, 4);
		   while(start >= 0 && start + sl < a[0].length) {  //limit loop to the length of the first array element
		      sl++;
		      iw.log("start: " + start + "; length: "+ sl, 4);
		      ts = a[0].substr(start, sl);
		      iw.log("next substring: " + ts, 4);
		      tmpA = a.filter(function(el){
		            return el.toLowerCase().includes(ts.toLowerCase());
		      });
		        
		      if(tmpA.length !== a.length) {
		      
		          ts = ts.substr(0, ts.length - 1);
		          iw.log("returning one character less. ts: " + ts, 4);
		          break;
		      }
		   
		   }
		   return ts;
		},
    
    parseContentType : function(contentType) {
      if(contentType == undefined) 
        return {}
      let parts = contentType.split(";").map(a => {return a.trim()});
      let type = parts[0];
      let result = {"type": parts[0]}
      if(parts.shift() !== undefined) {
        parts.map(a => {  
          let pt = a.split("=");
          result[pt[0]] = pt[1];
        });
      }
      return result;
    
    },
   
   invoke : function(service, data, onSuccess, onError) {
      var payload = {};
      if (data !== undefined) {
        payload = JSON.stringify(data);
      }
    
      try {
        var xhr = new XMLHttpRequest();
        //Add queryParameter 'jsonFormat' to override the corresponding Extended Setting 'watt.server.http.jsonFormat'
        xhr.open("POST", "/invoke/" + service.replace(":","/") + "?jsonFormat=parsed");
        xhr.setRequestHeader('Content-Type', 'application/json');
        xhr.setRequestHeader('Accept'      , 'application/json');
        //console.log("Posting to the IS");

        xhr.onreadystatechange = function() {
          //console.log("state: " + xhr.readyState);
          if(xhr.readyState == 4 ) {
            let contentType = iw.parseContentType(xhr.getResponseHeader('Content-Type'));
            if(xhr.status >= 200 && xhr.status < 300) {
              
              if(contentType.type === 'application/json') {  
                let parsedResult = JSON.parse(xhr.response);
                delete parsedResult.jsonFormat;
                onSuccess(parsedResult);
              }  else {
                //pass the raw response, along with the content-type
                onSuccess(xhr.response, contentType)
              }
            } else if (onError !== undefined){    
              var msg = xhr.response;
              if(contentType.type === 'application/json') {
                let errorResponse = JSON.parse(xhr.response);
                if(errorResponse.$error) {
                  msg = errorResponse.$errorType + ": " + errorResponse.$error;
                } 
                onError(msg, contentType, errorResponse);
                 
              } else {
                iw.log( "Content-Type: " +contentType.type, 1)
                try {
                  onError(msg, contentType, JSON.parse(msg));
                } catch {
                  onError(xhr.statusText, contentType, msg)
                }
              }

            }
          }
        }
         xhr.onerror = function(arg, msg) {
            iw.log("XHR Error:");
            iw.log(JSON.stringify(arg), 0);
            iw.log(JSON.stringify(xhr), 0);
            onError(msg);
         };
       
         xhr.upload.onerror = function(arg, msg) {
            iw.log("XHR Upload Error:");
            iw.log(arg);
            iw.log(xhr);
            iw.success = false;
            onError("Not connected anymore...")
         };
       
         xhr.onabort = function(arg) {
            iw.log("XHR Abort:");
            iw.log(arg);
            onError("Aborted");
         };
   
        xhr.send(payload);
      } catch(exception) {
          iw.log(exception, 0);
      }        
    },        
  
    listAliases: function() {
         iw.invoke("iw.test.alias:list", {}, function(data) {
            iw.availableAliases = data.aliases;
            if(data.aliases.length === 0 ) {
               //iw.availableAliases.push("(local)");              
            }                               
         });
    },
    
  }
  
  Vue.component('iw-menu' , {

    template: `
      <div class="main-header">
          <a href=""><img class="logo" src="img/iw-logo-61x23.png" style="position: relative; top: 5px; left: 5px"/></a>
 
          <div class="dropdown"      v-bind:class="{'menu-active' : item === 'testsuites'}" >Test Suites
            <div class="dropdown-content">
              <a href="testsuites.html"                                                     >Definitions</a>
              <a href="stats.html"                                                          >Static Code Coverage</a>
            </div>
          </div>

          <div class="dropdown"      v-bind:class="{'menu-active' : item === 'results'}"     >Results
            <div class="dropdown-content">
              <a href="results.html"                                         >Test Cases</a>
              <a href="coverage.html"                                        >Dynamic Code Coverage</a>
            </div>
          </div>

          <a href="record.html"      v-bind:class="{'menu-active' : item === 'record'}"     >Record</a>            

          <div class="dropdown"      v-bind:class="{'menu-active' : item === 'config'}"     >Configuration
            <div class="dropdown-content">
              <a href="settings.html"                                         >Settings</a>
              <a v-if="distributedEnabled === 'true'" href="environment.html" >Environment</a>
            </div>
          </div>

          <a href="logs.html"        v-bind:class="{'menu-active' : item === 'logs'}"       >Logs</a>
          <a href="index.html"       v-bind:class="{'menu-active' : item === 'docs'}"       >Docs</a>     
          <a href="about.html"       v-bind:class="{'menu-active' : item === 'about'}"      >About</a>     

        <div class="bell" v-if="latestVersion && currentVersion && latestVersion > currentVersion">
          <a href="about.html" v-bind:title="'v'+latestVersion+' is available'"><span class="glyphicon glyphicon-bell"></span></a>
        </div>

      </div>
      

      `,
      props: ['item', 'currentVersion', 'latestVersion', 'distributedEnabled'],
  });
  
  Vue.component('edit-text-field', {
  
    template: `
      <span>        
        <span v-if="editValue">
          <a href="#/" v-bind:disabled="!isDirty" v-on:click="valueChanged(value); " style="padding-right: 3px" > <span class="glyphicon glyphicon-ok"     aria-hidden="true" title="save"  /></a>
          
          <a href="#/"                            v-on:click="valueUnchanged();    " > <span class="glyphicon glyphicon-remove" aria-hidden="true" title="cancel"/></a>
          &nbsp;
          <select v-if="possibleValues" class="short" type="text" v-model='value' v-on:change="isDirty=true"  v-on:keyup.enter="valueChanged(value)">
             <option v-for="v in possibleValues">{{v}}</option>
          </select>
          <input v-else v-bind:style="{'width' : width +'px'}" v-bind:type="inputType" v-model='value' v-on:keyup="isDirty=true" v-on:keyup.enter="valueChanged(value)"/>
        </span>
        <span v-else>
          <a href="#/" v-bind:disabled="editValue" v-on:click="editValue = true" > <span class="glyphicon glyphicon-pencil" aria-hidden="true" title="edit"  /></a>
          &nbsp;
          <span v-if="enableClickEvent">
               <a class="event" href="#/" v-on:click="$emit('clicked')"> {{value}} </a>          
          </span>
          <span v-else>
              {{value}}
          </span>
        </span>
      </span>
    `,
    
    props: ['initialValue', 'possibleValues', 'inputType', 'enableClickEvent', 'initialEditValue', 'width'],
    
    data : function() {
      iw.log("[edit-text-field] props: initialValue:" + this.initialValue, 3)
      return {
        value:       this.initialValue,
        editValue:   this.initialEditValue? true : false,
        isDirty:     false
      }
    },
    
    methods : {
    
      valueChanged : function(value) {
        this.editValue = false;
        this.$emit('changed-value', value)
        this.isDirty = false;
      },
      
      valueUnchanged : function() {     
        this.editValue = false;
        this.value = this.initialValue;
        this.isDirty = false;
      } 
    }  
  });

  Vue.component('select-service' , {

    template: `
      <div class="container">        
      
        <div class="row" v-if="distributedEnabled === 'true' && aliasChangeable && availableAliases.length > 0" >
          <div class="column1">Remote server:</div>
          <div class="column2">
            <select v-model="alias" v-on:change="listPackages(alias)">
              <option disabled value="">Select an alias</option>
              <option></option>
              <option v-for="serverAlias in availableAliases">{{serverAlias}}</option>
           </select>                                          
          </div>
        </div>
        
        <div class="row" v-else-if="distributedEnabled === 'true' && alias">
          <div class="column1">Remote server:</div>
          <div class="column2">{{alias}}</div>            
        </div >
        
        <div class="row">
          <div class="column1">Package (optional):</div>
          <div class="column2">
            <select id="package-select"  v-bind:value="packageName" v-on:change="handlePackageChange($event)">
              <option></option>
              <option v-for="p in packages">{{p.name}}</option>
            </select>
          </div>
        </div>
      
        <div class="row">
          <div class="column1">Service:</div>
          <div class="column2">
            
            <input  style="width: 100%" v-bind:value="serviceName" v-on:paste="handleServiceNamePaste($event)" v-on:keyup="handleServiceNameChange($event)" type="text" placeholder="type service name"></input>
            <textarea v-show="filteredServices.length > 0 && !selected"
                      id="service-list-area" 
                      readonly 
                      v-bind:value="servicesText" 
                      v-bind:rows="filteredServices.length > 20 ? 20 : filteredServices.length" 
                      v-on:click="selectService"></textarea>
          </div>
        </div>                       
    
      </div>    
    `,
  
    props: ['distributedEnabled', 'initialAlias', 'initialPackages', 'initialServiceName', 'initialPackageName', 'aliasChangeable','availableAliases'],
  
    data : function() {
      return {
        alias:       this.initialAlias,
        packages:    this.initialPackages,
        serviceName: this.initialServiceName,
        packageName: this.initialPackageName,
        services: [],
        filteredServices : [],
        servicesText: "",
        selected: true
      }
    },
  
    methods: {
    
      setPackages : function(data) {
        iw.log("Retrieved packages", 3);
        if(data.packages) {
          this.packages = data.packages;
        } else {
          this.packages = [];
        }
      },
      
      
      listPackages : function (alias) {
        
        var params = {"$alias": alias};
        
        let rp = [];
        
        iw.invoke("iw.test.ui.ns:listPackages", params, this.setPackages); 
      
        this.$emit("update:alias", alias);
      },
    	serviceComparator : function(a, b) {
		    return a.nsname > b.nsname ? 1 : (b.nsname > a.nsname ? -1 : 0);
		  },
		  
      setServices : function(data) {
        this.services = data.services.sort(this.serviceComparator);
        iw.log("-- Retrieved services", 3);
        iw.log(this.services, 4);
        this.filteredServices = this.services;
        this.servicesText = this.filteredServices.map(function(s){return s.nsname}).join("\n");
        if(this.servicesText.length == 0) {
           this.servicesText = "<no matching services>";
        }      
      },
      
      retrieveServices : function(pkg, namePart) {
        let params = {"package": pkg === undefined || pkg === null ? "" : pkg , "serviceNamePart": namePart, "$alias" : this.alias};
        iw.invoke("iw.test.ui.ns:listServices", params , this.setServices, this.error);		       
      },
      
      handlePackageChange : function(event) {
        iw.log("-- Handling package change. Retrieving services for " + event.target.value, 3);
        //get hold of the newly selected package
        let pkg = event.target.value;
        this.selected = false;
        //Reset the service name
        this.serviceName = "";
        this.$emit('service-deselected');
        this.retrieveServices(pkg);
        this.packageName = pkg;
      },
      		
		  handleServiceNameChange : function(event) {
		    this.serviceName = event.target.value;
		    iw.log("Service name changed: event code: " + event.keyCode + "; service name: "+ this.serviceName, 3);  
		    iw.log(event,3);
		    this.selected = false;
		    this.$emit('service-deselected');
		    /*
		    - If there is no package selected, and the length of the service name part == 2, then and 
		      only then query the IS.
		      In all other cases, filter the list of services.
		    */
		    if(!this.packageName && this.serviceName && this.serviceName.length <= 2) {
		      if(this.serviceName.length == 2) {  
            iw.log("Service Name length == 2 and no package selected: retrieving services from IS", 3);
            this.retrieveServices(null, this.serviceName);
		      } else {
		        //clear the list of services and filtered services
		        this.services = [];
		        this.filteredServices = [];
		      }
		    } else {		       
		        this.filterServices();
 		        //Trying to the extend serviceName..
		        //The filtered service list is not changed here.
		        //But only if there is a filteredServicesList and if the user wasn't deleting characters
		        //event.keyCode 46 = delete
		        //event.keyCode  8 = backspace
		        iw.log("Event key code: " + event.keyCode, 3);
		        if(this.filteredServices.length > 0 && this.serviceName && this.serviceName.length > 2 && (event.keyCode != 46 && event.keyCode != 8)) {
                iw.log("Extending the service name...", 3);
                this.serviceName = iw.findLongestCommonString(this.serviceName, this.filteredServices.map(function(el){return el.nsname }));
                if(this.filteredServices.length == 1) {
                  this.serviceName = this.filteredServices[0].nsname;
                  this.selected = true;
                  this.$emit('service-selected', this.serviceName);    
                }
		        }
		        //end smart extension of the service name
		    }
		  },
		  
		  handleServiceNamePaste : function () {
		    var pastedString = event.clipboardData.getData('text');
		    iw.log("Service name pasted in: event code: " + event.keyCode + "; service name: "+ pastedString, 3);  		    
		    this.retrieveServices(null, pastedString);
		    this.serviceName = pastedString;
		  },
		  
		  filterServices : function () {
         iw.log("Filtering service list", 3);  
		     if(this.serviceName) {
     		    let s = this.serviceName.toLowerCase();
 		        iw.log("service name part: " + s, 4);
		      	this.filteredServices = this.services.filter(function(a){
              let result = false;
              if (a.nsname.toLowerCase().includes(s)) {
                result = true;
              } 
              iw.log(a.nsname + " qualifies? " + result, 4);
		          return result
		        });
		      } else {
		        this.filteredServices = this.services;
		      }
		    this.servicesText = this.filteredServices.map(function(s){return s.nsname}).join("\n");
        if(this.servicesText.length == 0) {
           this.servicesText = "<no matching services>";
        }  
		  },
		     
      selectService : function(event) {
		    //Capture the selected text. When we get here, the user has clicked in the
		    //textarea with services. Copy the service name to the main text field.
          //We need to do some string manipulation. From the cursor position in the 
          //textarea we deduce the who line = service name
 		    if(document.getSelection) {
              
              var ta = document.getElementById("service-list-area");
              var s = ta.value.substring(ta.selectionStart, ta.selectionEnd);
              var start = ta.value.lastIndexOf("\n", ta.selectionStart) + 1;  //exclude the new line from the selection
              var end = ta.value.indexOf("\n", ta.selectionStart); 
              if(end < 0) {
                  end = ta.value.length;
              } else if(ta.value.indexOf("\r", ta.selectionStart) > 0 && ta.value.indexOf("\r", ta.selectionStart) < end) {
                  end = ta.value.indexOf("\r", ta.selectionStart);
              }
              var selectedService = ta.value.substring(start, end);
              this.serviceName = selectedService;
              this.selected = true;
              this.$emit('service-selected', selectedService);
              iw.log("Computed: '" + ta.value.substring(start, end) + "' start: " + start + "; end: "+ end, 3);
           } else {
              selectedService = window.getSelection().toString()
              if(selectedService.length > 2 ) {
           }     		        		
		        
		    }
		},
      
    }
  });
    
  Vue.component('select-service-modal', {
  
    template : `
      <div style="display: inline-block">
        
        <div>
          <a href="#/" v-on:click="showSelectServiceModal()"> 
             <span class="glyphicon glyphicon-search" aria-hidden="true"></span>
          </a>
          &nbsp;
          <span v-if="service !== undefined && service !== null && service !== '' && !noDisplay">  
            <a href="#/" v-on:click="clearService()">
              <span class="glyphicon glyphicon-remove" aria-hidden="true" ></span>
            </a>
            &nbsp;&nbsp;{{service}}   
          </span>
        </div>
        
        <div class="modal" v-if="showModal">
          <div class="modal-box select-service-modal" style="z-index: 995" id="selectservicemodal" >
        
            <div class="table">
              <div class="header">Search Service</div>
            </div>          

            <div class="table container">

              <select-service v-bind:initial-alias        = "initialAlias"
                              v-bind:initial-packages     = "initialPackages"                            
                              v-bind:initial-package-name = "initialPackageName"
                              v-bind:alias-changeable     = "true"         
                              v-bind:distributed-enabled  = "distributedEnabled"
                              v-bind:available-aliases    = "availableAliases" 
                              v-on:service-selected       = "selectedService = $event"
                              v-on:update:alias           = "selectedAlias = $event"
              ></select-service>
              <!-- v-bind:initial-service-name = "initialServiceName" -->
            
              <div class="header">
            
                   <button class="btn" v-bind:disabled="false" type="submit" v-on:click="assignSelectedService()">
                       <span class="glyphicon glyphicon-play"></span> Select Service</button>
            
                   <button class="btn" v-bind:disabled="false" type="submit" v-on:click="hideSelectServiceModal()"> 
                        <span class="glyphicon glyphicon-remove"style="color: #E2F9EB" aria-hidden="true"></span> Cancel</button>

              </div>          
             
            </div>          
          
          </div>
        </div>
        

      </div>
    `, 
    
     props: ['distributedEnabled', 'initialAlias', 'initialPackages', 'initialServiceName', 'initialPackageName', 'aliasChangeable','availableAliases', 'noDisplay'],
  
     data : function() {
       return {
          service:         this.initialServiceName,
          selectedService: this.initialServiceName,
          selectedAlias:   this.initialAlias,
          showModal: false
      }
    },
    
    methods : {
      
      assignSelectedService : function() {
        this.service   = this.selectedService;
        this.showModal = false;
        this.$emit('service-selected', this.service )
        this.$emit('update:alias', this.selectedAlias)
      },
      
      clearService : function() {
        this.service = "";
        this.$emit('service-selected', this.service )
      },
      
      showSelectServiceModal : function() {
          this.showModal = true;
          this.$emit('search-icon-clicked', true)
      },
      
      hideSelectServiceModal : function() {
        this.showModal = false;      
        this.$emit('search-modal-closed', true)
      }    
    }  
  });
  
  Vue.component('select-file', {
  
    template: `   
      <div style="display : inline-block">
      
        <!-- Start inline icons -->
        <div>
          <a href="#/" v-on:click="showSelectFileModal()">   <span class="glyphicon glyphicon-search" aria-hidden="true"></span></a>
          &nbsp;                    

          <span v-if="isFile && initialFileName && initialFileName !== ''">
             <a  v-bind:title="'Edit '    + initialFileName"    href="#/" v-on:click="editFile()"> <span class="glyphicon glyphicon-pencil" aria-hidden="true"></span></a> &nbsp;
          </span>
          
          <span v-if="isFile && initialFileName && initialFileName !== ''" >
            <a  v-bind:title="'Download ' + initialFileName"    v-bind:href="'/invoke/iw.test.util.file/getContent?base-dir=' + baseDir + '&file-name=' + fileName" v-bind:download="downloadPrefix.replace(':','.') + '-' + fileName"> <span class="glyphicon glyphicon-download" aria-hidden="true"></span> </a>  
            &nbsp;
          </span>

          <span v-if="initialFileName && initialFileName.length > 0">  
            <a v-bind:title="'Remove '    + initialFileName"     href="#/" v-on:click="clearFile()">  <span class="glyphicon glyphicon-remove" aria-hidden="true" ></span></a>
            &nbsp; 
          </span>
          <span>{{initialFileName}}</span>
        </div>        
        <!-- End inline icons -->      
        
        <!-- start file modal -->
        <div class="modal" v-if="showModal">
        
          <div class="modal-box select-file-modal" id="selectfilemodal" >
        
            <table style="text-align: left; " class="table">  <!-- test suite table -->
              <thead>
                <tr>
                  <th>
                   <button class="btn" v-bind:disabled="false" type="submit" v-on:click="hideSelectFileModal()"> 
                    <span class="glyphicon glyphicon-remove"style="color: #E2F9EB" aria-hidden="true"></span> Close</button>
                    
               <button class="btn" v-if="isFile" type="submit" v-on:click="selectFile()"> 
                    <span class="glyphicon glyphicon-ok"style="color: #E2F9EB" aria-hidden="true"></span> Select file</button>
                        
               <button class="btn" v-if="!isFile" type="submit" v-on:click="selectDirectory()"> 
                    <span class="glyphicon glyphicon-ok"style="color: #E2F9EB" aria-hidden="true"></span> Select folder</button>
                  </th>
                </tr>
                <tr>
                  <th colspan="2" >Folder: {{dir}}</th>
                </tr>
                <tr v-if="isFile">
                  <th colspan="2" >File: {{fileName}}</th>
                </tr>              
              </thead>
            
            </table>
          
            <div class="scrolltable">
              <table style="text-align: left" class="table">
                <thead>
                  <tr>               
                      <th>name</th>
                      <th style="text-align: right">size (bytes)</th>
                      <th style="text-align: right"">last modified</th>
                  </tr>
                </thead>
                
                <tbody> 
                
                  <tr v-if="dir.length > baseDir.length">
                    <td>
                      <span class="glyphicon glyphicon-directory"></span>
                      &nbsp;
                      <a href="#/" v-on:click="getDirContents(parent)"> ..</a>
                    </td>
                    <td></td>
                    <td></td>
                  </tr>
                
                  <tr v-for="(item, idx) in dirContents">
              
                    <td>              
                      <span v-if="item['is-dir']" class="glyphicon glyphicon-directory"></span>
                      <span v-else                class="glyphicon glyphicon-file"></span>              
                  
                      &nbsp;
               
                      <a v-if="item['is-dir']" href="#/" v-on:click="getDirContents(dir, item.name)"> {{item.name}}</a>
                      <a v-else                href="#/" v-on:click="fileName=item.name"> {{item.name}}</a>
                    </td>
                    <td style="text-align: right">{{item.size}}</td>
                    <td style="text-align: right">{{item['last-modified-date']}}</td>
                  </tr>
                </tbody>

              </table>
            
            </div>
          
          </div>
        </div>

        <!-- End file modal -->        
        
        
      </div>
   `,
    
    props: ['initialBaseDir', 'initialFileName', 'packageName', 'isFile', 'downloadPrefix'],
    
    data : function () {
      iw.log("Initializing 'select-file' component. baseDir: " + this.initialBaseDir + "; is-file: " + this.isFile + "; fileName: " + this.initialFileName, 3)       

      if(this.isFile) {
        this.getDirContents(this.initialBaseDir);        
      } else {
        this.getDirContents(this.initialBaseDir, this.initialFileName); 
      }

      return {
        dir        : this.isFile ? this.initialBaseDir : this.initialFileName,
        baseDir    : this.initialBaseDir,
        dirContents: [],
        parent     : ".",
        fileName   : this.isFile? this.initialFileName : '',
        showModal  : false
      }    
    },
    
    methods : {
      getDirContents : function(dir, item) {
              
        iw.log("[select-file] 'getDirContents called. dir: " + JSON.stringify(dir), 3);
        if(dir === null || "" === dir) return;
        this.fileName = ""
        if(this.baseDir !== undefined) {
          if(dir.length < this.baseDir.length) {
            dir = this.baseDir;
          }
        } else {
          if(dir.length < this.initialBaseDir.length) {
            dir = this.initialBaseDir;
          }        
        }
        let self = this;
        let params = {dir: dir }
        if(item !== undefined && dir !== "") params = {dir: dir + "/" + item}
        if(item !== undefined && dir === "") params = {dir: item}
        
        iw.log("Retrieving folder contents for: " + JSON.stringify(params), 3);
        iw.invoke("iw.test.util.file:list", params, function(data){
          if(data.children !== undefined) {
            self.assignFolderData(data);    
          }  else {

            //if there are no children, then the directory doesn't exist. In that case, the directory is probably relative
            //to the package
            let bdir = "packages/" + self.packageName;
            iw.log("Folder not found. Trying with " + bdir, 3)
            
            params = {dir: bdir}
              iw.invoke("iw.test.util.file:list", params, function(data){     
                if(data.children !== undefined) {
                   self.baseDir = bdir;
                   self.assignFolderData(data);
                } else {
                   //Issue error message?
                }              
              });            
          }

        });
        
      },
      
      assignFolderData : function(data) {
        this.parent = data.parent;
        this.dir    = data.dir;
        if(data.children !== undefined) {
            this.dirContents = data.children.sort(function(a,b){ 
              if(a['is-dir'] && !b['is-dir'] ) {
                return -1;
              } else if(!a['is-dir'] && b['is-dir']) {
                return 1;
              } else {
                if(a.name >= b.name) return 1; else return -1;
              }             
            });      

            this.dirContents.map(function(a){a['last-modified-date'] = (new Date(a['last-modified'])).toLocaleString()}); 

          }            
      },
      
      clearFile : function() {
        this.fileName = '';
        this.$emit('file-selected', '')
      },
      
      editFile :  function() {
        //Substract baseDir from dir
        let subDir = this.dir.substring(this.baseDir.length + 1)
        //Only prepend subDir plus a slash if it has a value
        this.$emit('edit-file', {baseDir: this.baseDir, fileName: subDir.length > 0 ? subDir +  "/" + this.fileName : this.fileName})
      },
      
      
      selectFile : function() {
        //Substract baseDir from dir
        let subDir = this.dir;
        if(this.baseDir) subDir = this.dir.substring(this.baseDir.length + 1);
        this.showModal = false;
        //Only prepend subDir plus a slash if it has a value
        iw.log("Selecting file. fileName: " + this.fileName + "; subDir: " + subDir, 3);
        this.$emit('file-selected', subDir.length > 0 ? subDir +  "/" + this.fileName : this.fileName );
      },
      
      selectDirectory : function() {
         let subDir = this.dir.substring(this.baseDir.length )
         //Remove the slash if subDir is defined
         if(this.baseDir.length > 0) subDir = subDir.substring(1);
         this.showModal = false;
         this.$emit('file-selected', subDir  )
      },
      
      showSelectFileModal : function() {
          this.showModal = true; 
          //Rescan the directory everytime the modal is activated
          this.getDirContents(this.initialBaseDir);
      },
      
      hideSelectFileModal : function() {
        this.showModal = false;      
      },
      
      showEditFileModal : function() {
        this.showModal = false;
        this.$emit('edit-file')
      }
      
            
      
    }
  
  });
  
        
})(this, undefined);
